/* ======================================================
 Script information

 file name   :jquery.css3gridtable.js
 book info   :CSS3デザインプロフェッショナルガイド
 author      :秋葉秀樹、秋葉ちひろ、宮澤了祐
 created     :2011.05.28
 update      :-
 script info :
   ・項目のソート機能：各項目を降順・昇順にソートします。
	 ・行・列のハイライト機能：現在マウスカーソルがある行・列をハイライトします。
	 ・項目の編集機能（標準はオフ）：セルごとにその場で編集できるようにします。
====================================================== */

$(function(){
	$.fn.css3gridTable = function(options){
		var table = $(this),tbody = table.find("tbody");
		options = $.extend({
			editable : false,
			onChange : function(col,row,value){
				
			}
		},options);
		
		var table_sort  = function(ele){
			col_class = $(ele).attr("class").replace(/.*(col-[0-9]+).*/,"$1");
			if(ele.hasClass("asc")){
				_table_sort(col_class,false);
				$(".asc").removeClass("asc");
				$(".desc").removeClass("desc");
				
				ele.removeClass("asc").addClass("desc");
			}else{
				_table_sort(col_class,true);
				$(".asc").removeClass("asc");
				$(".desc").removeClass("desc");
				ele.removeClass("desc").addClass("asc");
			}
		};
		
		//number
		var is_numeric = function(input){
			if(input.indexOf(",") > 0){
				input = input.replace(",","");
				return is_numeric(input);
			}
			return (input - 0) == input && input.length > 0;
		};
		
		var _parseInt = function(input){
			input = input.replace(",","");
			return parseInt(input);
		}
		
		var _table_sort = function(_class,order){
			rows = [];
			table.find("tbody ." + _class).each(function(index){
				rows[index] = [
					$(this).parents("tr"), $(this).html()
				];
			});
			//sort
			rows.sort(function(a,b){
				if(is_numeric(a[1]) && is_numeric(b[1])){
					if(order){
						return (_parseInt(a[1]) > _parseInt(b[1])) ? 1 : -1;
					}else{
						return (_parseInt(a[1]) > _parseInt(b[1])) ? -1 : 1;
					}
				}
				
				if(order){
					return ([a[1],b[1]].sort()[0] == a[1]) ? -1 : 1;
				}else{
					return ([a[1],b[1]].sort()[0] == a[1]) ? 1 : -1;
				}
			});	
			for(var i in rows){
				tbody.append(rows[i][0]);
			}
		}
		//thead
		table.find("thead tr th").click(function(e){
			table_sort($(this));
			
			$("td.active,th.active").removeClass("active");
			$("." + $(this).attr("class").replace(/.*(col-[0-9]+).*/,"$1")).addClass("active");
			return false;
		});
		table.find("tr").each(function(row_index){
			$(this).find("td,th").each(function(index){
				$(this).addClass("col-" + index).addClass("row-" + row_index).addClass("css3tablcolumn")
					.data("row",row_index).data("col",index);
			})
		});
		
		table.find("td.css3tablcolumn").bind("mouseover",function(){
				var cell = $(this),
				col=cell.data("col"),row=cell.data("row");
				
				table.find(".over").removeClass("over");
				table.find(".col-" + col).addClass("over");
				table.find(".row-" + row).addClass("over");
		});
		
		table.bind("mouseout",function(){
			table.find(".over").removeClass("over");
		});
		
		if(options.editable != false){
			var call_onchange = function(col,row,value){
				return options.onChange(col,row,value);
			};
			table.find("td.css3tablcolumn").click(function(){
					var val = $(this).html(),cell = $(this),
						col=cell.data("col"),row=cell.data("row");
						
					if(options.editable != true){
						_classes = options.editable.split(",");
						has_class = false;
						for(var i in _classes){
							if(cell.hasClass(_classes[i])){
								has_class = true;
								break;
							}
						}
						if(!has_class)return;
					}
					
					if($(this).find("input").size() > 0){
						if(false !== call_onchange(col,row,$(this).find("input").val())){
							cell.html($(this).find("input").val());
						}
						return;
					}
					
					$(this).html("<input type=\"text\" class=\"css3table-edit\" />");
					input = $(this).find("input").val(val).select();
					input.bind("blur",function(){
						if(false !== call_onchange(col,row,$(this).val())){
							cell.html($(this).val());
						}
						
					}).bind("keydown",function(event){
						 if (event.keyCode == '13') {
						 	event.preventDefault();
						 	if(false !== call_onchange(col,row,$(this).val())){
							 	cell.html($(this).val());
							 }
						 }
					});
			});
		}
		
		return $(this);
	};
});